﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Net;
using System.Text;
using System.Windows.Forms;
using System.Xml.Linq;
using GVUZ.ImportServiceTest.Properties;

namespace GVUZ.ImportServiceTest
{
	public partial class MainForm : Form
	{
		public MainForm()
		{
			InitializeComponent();
		}

		private void comboBox1_SelectedIndexChanged(object sender, EventArgs e)
		{
			string res = this.textBox1.Text.Trim();
			string res2 = this.comboBox1.SelectedItem as string;
			if (!String.IsNullOrEmpty(res2))
				res2 = res2.Substring(0, res2.IndexOf(" "));
			this.textBox2.Text = res + res2;
			this.textBox3.Enabled = res2 == null || !res2.Contains("/test/");
		}

		private void button1_Click(object sender, EventArgs e)
		{
			WebClient cl = new WebClient();
			cl.Encoding = Encoding.UTF8;
			cl.Headers["Content-Type"] = "text/xml";
			string url = this.textBox2.Text;
			try
			{

				if (url.Contains("/test/"))
				{
					this.textBox4.Text = cl.DownloadString(url);
				}
				else
				{
					this.textBox4.Text = cl.UploadString(url, this.textBox3.Text);
				}
			}
			catch (WebException ex)
			{
				this.textBox4.Text = ex.ToString();
			}
			FormatOutput();
			
		}

		private void FormatOutput()
		{
			try
			{
				var xElement = XElement.Load(new StringReader(this.textBox4.Text));
				this.textBox4.Text = xElement.ToString(SaveOptions.None);
			}
			catch (Exception)
			{
			}
		}

		private void MainForm_FormClosing(object sender, FormClosingEventArgs e)
		{
			Settings.Default.Save();
		}

		private void MainForm_Load(object sender, EventArgs e)
		{
			comboBox1_SelectedIndexChanged(sender, e);
		}

		private void textBox3_KeyDown(object sender, KeyEventArgs e)
		{
            if (e.Control && (e.KeyCode == System.Windows.Forms.Keys.A))
            {
                ((RichTextBox)sender).SelectAll();
                e.SuppressKeyPress = true;
                e.Handled = true;
            }
            else
                base.OnKeyDown(e);
		}

		private void button2_Click(object sender, EventArgs e)
		{
			string s = this.textBox3.Text;
			if (String.IsNullOrWhiteSpace(s))
				s = "<Root></Root>";
			XElement xElement = null;
			try
			{
				xElement = XElement.Load(new StringReader(s));
			}
			catch (Exception)
			{
				MessageBox.Show("Неверный XML");
				return;
			}
			if(xElement.Elements("AuthData").Count() > 0)
				xElement.Elements("AuthData").ToList().ForEach(x => x.Remove());

			XElement auth = new XElement("AuthData", new XElement("Login", this.textBox5.Text.Trim()), new XElement("Pass", this.textBox6.Text.Trim()));
			//XElement auth = XElement.Load(String.Format("<AuthData><Login>{0}</Login><Pass>{1}</Pass></AuthData>", this.textBox5.Text.Trim(), this.textBox6.Text.Trim()));
			//xElement.Add(new XElement("test"));
			xElement.AddFirst(auth);
			this.textBox3.Text = xElement.ToString();

		}
	}
}
